% A series of linear buffers
def(test(In, Y), pref(in(In,X), proc(test(In, X)))).

def(buf1(In,Out), pref(in(In,X), pref(out(Out,X), proc(buf1(In,Out))))).
def(buf2(In,Out), nu(M, par(proc(buf1(In,M)),proc(buf1(M,Out))))).
def(buf3(In,Out), nu(M, par(proc(buf1(In,M)),proc(buf2(M,Out))))).
def(buf4(In,Out), nu(M, par(proc(buf1(In,M)),proc(buf3(M,Out))))).
def(buf5(In,Out), nu(M, par(proc(buf1(In,M)),proc(buf4(M,Out))))).
def(buf6(In,Out), nu(M, par(proc(buf1(In,M)),proc(buf5(M,Out))))).
def(buf7(In,Out), nu(M, par(proc(buf1(In,M)),proc(buf6(M,Out))))).
def(buf8(In,Out), nu(M, par(proc(buf1(In,M)),proc(buf7(M,Out))))).
def(buf9(In,Out), nu(M, par(proc(buf1(In,M)),proc(buf8(M,Out))))).
def(buf10(In,Out), nu(M, par(proc(buf1(In,M)),proc(buf9(M,Out))))).
def(buf11(In,Out), nu(M, par(proc(buf1(In,M)),proc(buf10(M,Out))))).
def(buf12(In,Out), nu(M, par(proc(buf1(In,M)),proc(buf11(M,Out))))).
def(buf13(In,Out), nu(M, par(proc(buf1(In,M)),proc(buf12(M,Out))))).
def(buf14(In,Out), nu(M, par(proc(buf1(In,M)),proc(buf13(M,Out))))).
def(buf15(In,Out), nu(M, par(proc(buf1(In,M)),proc(buf14(M,Out))))).
def(buf16(In,Out), nu(M, par(proc(buf1(In,M)),proc(buf15(M,Out))))).
def(buf17(In,Out), nu(M, par(proc(buf1(In,M)),proc(buf16(M,Out))))).
def(buf18(In,Out), nu(M, par(proc(buf1(In,M)),proc(buf17(M,Out))))).
def(buf19(In,Out), nu(M, par(proc(buf1(In,M)),proc(buf18(M,Out))))).


def(buf(V),
    nu(M, nu(Out,
            par(proc(buf16(M,Out)),
            par(proc(input(Out)),
                proc(output(M,V))))))).

def(output(Out,V), pref(out(Out,V), proc(output(Out,V)))).

def(input(In), pref(in(In,X), proc(input(In)))).

%% Properties: Deadlock
%% Command: mck(buf1(i,o),deadlock) - buf1 can be replaced by buf2,...
%% Result: No
fDef(deadlock,fOr(fBoxSetMinus([],ff),fDiamSetMinus([],form(deadlock)))).  

fDef(deadlock1,fOr(fBox(tau,ff),fDiam(tau,form(deadlock1)))).

%% Property: Order is not preserved
%% command: mck(buf1(i,o), nfdo(i,o)).
%% Result: No
fDef(nfdo(In, Out) , fOr(fDiamMinus(in(In, _), form(nfdo(In, Out))),
                        fDiam(in(In, Val), form(nop(Out, Val))))).
fDef(nop(Out, Val), fOr(fDiam(out(Out, NewVal), pred(Val \== NewVal, tt)),
                        fDiamMinus(out(Out, _), form(nop(Out, Val))))).

%% Property: Lost input
%% command: mck(buf1(i,o), inop(i,o)).
%% Result: No
fDef(inop(In, Out), fOr(fDiamSetMinus([],form(inop(In, Out))),
                        fDiam(in(In, Val),neg_form(nopp(Out,Val))))).
fDef(nopp(Out,Val), fAnd(fAnd(fAnd(fOr(
     fBox(out(Out,NewVal), pred(Val == NewVal, tt)),
     fBox(out(Out,NewVal), pred(Val \== NewVal, form(nopp(Out, Val))))),
     fDiamSetMinus([],tt)),
     fBox(in(In,_),form(nopp(Out,Val)))),
     fBox(tau,form(nopp(Out,Val))))).
