% :- assert(start($StartState)), count(state(_),N)
% :- count(reachable_transitions(_,_,_),N).

:- table state/1.
state(S) :- state(T), transition(T, _, S).
state(S) :- start(S).

:- table reachable_transitions/3.
reachable_transitions(S,A,T) :- state(S), transition(S,A,T).

:- import conget/2, conset/2 from gensym.

incr(Counter) :-
        conget(Counter, N),
        N1 is N + 1,
        conset(Counter, N1).
incr(Counter, DisplayIncrement) :-
        conget(Counter, N),
        N1 is N + 1,
        conset(Counter, N1),
        (0 is N1 mod DisplayIncrement
	 ->	(write(N1), write(' '))
	 ;	true
	).

zero(Counter) :-
       conset(Counter, 0).
       
count(C, _) :- zero(c), call(C), incr(c), fail.
count(_, N) :- conget(c, N).
count(C, _, D) :- zero(c), call(C), incr(c,D), fail.
count(_, N, _) :- conget(c, N).


