:- import numbervars/1 from num_vars.
:- import member/2, reverse/2 from basics.
dlpath(Path) :-
	state(S),
	\+ transition(S, _, _),
	start(Start),
	path(Start, S, [Start], RevPath),
	reverse(RevPath, Path).

path(S, S, Path, Path).
path(S, T, Sofar, Path) :-
	transition(S, _, U),
	not member(U, Sofar),
	path(U, T, [U|Sofar], Path).

dumpdl([]).
dumpdl([S1|Ss]) :-
	intern(S, S1),
	numbervars(S), 
	writeln(S), nl,
	dumpdl(Ss).
dumpdl :-
	dlpath(Path),
	dumpdl(Path).

dump :-
	reachable_transitions(S1, A, T1),
	intern(S, S1), intern(T, T1),
	numbervars((S,A,T)),
	write('Source : '), writeln(S),
	write('Action : '), writeln(A),
	write('Target : '), writeln(T),
	nl,
	fail;
	true.