%% Handover procedure, originally from Orava/Parrow'92
%% Taken from Victor/Moller'94
%% 1000.02 sec.

def(cc(In, L, F),
   choice(
      pref(in(In, V),
         pref(out(F, data),
	   pref(out(F, V),
	     proc(cc(In, L, F))))),
      pref(in(L, K),
         pref(in(K, Fnew),
           pref(in(K, Mnew),
	      pref(out(F, ho_cmd),
		 pref(out(F, Mnew),
		   choice(
		       pref(in(Fnew, C),
			 match((C = ho_com),
			    pref(out(F, ch_rel),
			       pref(in(F, M),
			          pref(out(K,F),
			             pref(out(K, M),
			      	        proc(cc(In, L, Fnew)))))))),
		      pref(in(F, C1),
		         match((C1 = ho_fail),
			   pref(out(K, Fnew),
			      pref(out(K, Mnew),
			         proc(cc(In, L, F)))))))))))))).


def(cce(In1, In2, L, F1, F4),
   par(
      proc(cc(In1, L, F1)),
      proc(cc(In2, L, F4)))).


def(hc(L, F, M),
    nu(K,
       pref(out(L, K),
          pref(out(K, F),
             pref(out(K, M),
	 	pref(in(K, Fnew),
		   pref(in(K, Mnew),
	              proc(hc(L, Fnew, Mnew))))))))).


def(hce(L, F2, F3, M2, M3),
   par(proc(hc(L, F2, M2)),
	    proc(hc(L, F3, M3)))).


def(msc(In1, In2, F1, F4, F2, F3, M2, M3),
    nu(L,
       par(proc(hc(L, F2, M2)),
         par(proc(hc(L, F3, M3)),
	    par(proc(cc(In1, L, F1)),
              proc(cc(In2, L, F4))))))). 


def(rcca(F, M),
    pref(in(F, C),
       choice(
	  match((C=data),
	     pref(in(F, V),
		pref(out(M, data),
		   pref(out(M, V),
		      proc(rcca(F, M)))))),
	  match((C=ho_cmd),
	     pref(in(F, V),
		pref(out(M, ho_cmd),
		   pref(out(M, V),
		      choice(
			 pref(in(F, C1),
			    match((C1=ch_rel),
			       pref(out(F, M),
				  proc(rccp(F, M))))),
			 pref(in(M, C2),
			    match((C2=ho_fail),
			      pref(out(F, ho_fail),
			         proc(rcca(F, M))))))))))))).


def(rccp(F, M),
    pref(in(M, C),
	 match((C = ho_acc),
	       pref(out(F, ho_com),
		    proc(rcca(F, M)))))).


def(ms(M, Out),
    pref(in(M, C),
      choice(
	match((C = data),
	   pref(in(M, V),
	      pref(out(Out, V),
		proc(ms(M, Out))))),
	match((C = ho_cmd),
           pref(in(M, Mnew),
	      choice(
                 pref(out(Mnew, ho_acc),
		    proc(ms(Mnew, Out))),
		 pref(out(M, ho_fail),
		    proc(ms(M, Out))))))))).


def(system(In1, In2, Out1, Out2),
   nu(F1, nu(F2, nu(F3, nu(F4,
      nu(M1, nu(M2, nu(M3, nu(M4,
         par(proc(msc(In1, In2, F1, F4, F2, F3, M2, M3)),
	     par(proc(rcca(F1, M1)),
	        par(proc(rccp(F2, M2)),
	        par(proc(rccp(F3, M3)),
		   par(proc(rcca(F4, M4)),
		   par(proc(ms(M1, Out1)),
		       proc(ms(M4, Out2))))))))))))))))).


def(s3(V1,V2,V3),
    pref(out(out, V1),
	 proc(s2(V2,V3)))).

% Service specification, out-of-order service.

def(spec1,
    choice(
	   pref(in(in, V),
		proc(s11(V))),
	   pref(tau,
		proc(spec1)))).

def(s11(V1),
    choice(
	   pref(in(in, V),
		proc(s12(V, V1))),	%out of order here...
	   choice(
		  pref(out(out, V1),
		       proc(spec1)),
		  pref(tau,
		       pref(out(out, V1),
			    proc(spec1)))))).

def(s12(V1,V2),
    choice(
	   pref(in(in, V),
		proc(s13(V1,V2,V))),
	   choice(
		  pref(out(out, V1),
		       proc(s11(V2))),
		  pref(tau,
		       pref(out(out, V1),
			    pref(out(out, V2),
				 proc(spec))))))).
def(s13(V1,V2,V3),
    pref(out(out, V1),
	 proc(s12(V2,V3)))).


%% deadlock += [-]ff \/ <-> deadlock
%% Property: Deadlock
%% Command:  mck(system,deadlock).
%% Result: No
fDef(deadlock,fOr(fBoxSetMinus([],ff),fDiamSetMinus([],form(deadlock)))).

/*fDef(inop(In, Out), fOr(fDiamSetMinus([],form(inop(In, Out))),
                        fDiam(in(In, Val),neg_form(nopp(In,Out,Val))))).
fDef(nopp(In,Out,Val), fAnd(
        fDiamSetMinus([],tt),
        fAnd(fBox(tau,form(nopp(In, Out,Val))),
        fAnd(fBox(in(_,_),form(nopp(In, Out,Val))),
        fAnd(fBox(i,form(nopp(In,Out,Val))),
	fOr(fBox(out(Out1,V), pred(Out1 \== Out, form(nopp(In,Out,Val)))),
        fBox(out(Out,NewVal), fOr(pred(Val == NewVal, tt),
pred(Val \== NewVal, form(nopp(In,Out,Val))))))))))).*/


fDef(inop(In, Out), fOr(fDiamSetMinus([],form(inop(In, Out))),
                        fDiam(in(In, Val),neg_form(nopp(In,Out,Val))))).
fDef(nopp(In,Out,Val), fAnd(
        fDiamSetMinus([],tt),
        fOr(fDiamMinus(out(Out,_),form(nopp(In, Out,Val))),
        fDiam(out(Out,NewVal), fOr(pred(Val == NewVal, tt),
pred(Val \== NewVal, form(nopp(In,Out,Val)))))))).

/*
fDef(inop(In, Out), fDiam(in(In, Val),neg_form(nopp(In,Out,Val)))).

fDef(nopp(In,Out,Val), fAnd(
        fDiamSetMinus([],tt),
        fOr(fDiamMinus(out(Out,_),form(nopp(In, Out,Val))),
        fDiam(out(Out,NewVal), fOr(pred(Val == NewVal, tt),
pred(Val \== NewVal, form(nopp(In,Out,Val)))))))).*/
