:- [utils,mucalculus,comp,count].

init(sym) :-
	[sym, transition].
init(nosym) :-
	[nosym, transition_nosym].

version(System, buf1, 'buffer: deadlock ', System).

formula_version(deadlock, deadlock).
formula_version(ndl, inop(in, out)).

gen(Version) :-
	version(Version, File, Name, Start),
	consult(File),
	writeln('********************'),
	writeln(Name),
	writeln('********************'),	
	statistics(0), nl,
	write('***** Compilation: '),
	gen_trans(Start), nl,
	statistics.

:- dynamic started/0, done/0.
run(Version, Formula) :-
	retractall(started), retractall(done),
	version(Version, _, _, Start),
	formula_version(Formula, Form),
	statistics(0), nl,
	write('***** Property '), write(Formula), write(' is '),
	((assert(started), mck(Start, Form),
	  (done -> true; assert(done), write('TRUE')))
	 ; (started, \+ done, write('FALSE'))
	),
	writeln(' *****'), nl,
	statistics.

stats(Version) :-
	version(Version, _, _, Start),
	get_stats(Start, S, T), nl,
	write('Number of States = '), writeln(S),
	write('Number of Transitions = '), writeln(T).

all(SystemOption, Version, Formula) :-
	init(SystemOption),
	gen(Version),
	run(Version, Formula),
	stats(Version).
