:- [utils,mucalculus,servernew1,count].

init(sym) :-
	[comp, sym, transition].
init(nosym) :-
	[comp, nosym, transition_nosym].
init(net) :-
	[comp_net, sym, transition_net].

get_state(Size, Start) :-
	name(Size, Sz),
	name(s, [S]),
	name(Start, [S|Sz]).

gen(Size) :-
	get_state(Size, Start),
	statistics(0), nl,
	gen_trans(Start),
	statistics.

:- dynamic started/0, done/0.
run(Size) :-
	retractall(started), retractall(done),
	get_state(Size, Start),
	statistics(0), nl,
	write('***** Property nop is '),
	((assert(started), mck(Start, nop),
	  (done -> true; assert(done), write('TRUE')))
	 ; (started, \+ done, write('FALSE'))
	),
	writeln(' *****'), nl,
	statistics.

stats(Size) :-
	get_state(Size, Start),
	get_stats(Start, S, T), nl,
	write('Number of States = '), writeln(S),
	write('Number of Transitions = '), writeln(T).

all(SystemOption, Size) :-
	init(SystemOption),
	gen(Size),
	run(Size),
	stats(Size).




a1 :-
        statistics(0),
        gen_trans(proc(s20),s), statistics.

run1 :- 
        statistics(0),
	mck(s2,nop), writeln(yes), statistics, !.
run1 :-  writeln(no), statistics.

s1(N,N1) :- retractall(start(_)), gen_start_state(proc(s2), StartState), assert(start(StartState)), count(state(_),N), 
	count(reachable_transitions(_,_,_),N1).


run2 :-
        statistics(0),
	mck(s3,nop), writeln(yes), statistics, !.
run2 :-  writeln(no), statistics.

s2(N,N1) :- retractall(start(_)), gen_start_state(proc(s3), StartState), assert(start(StartState)), count(state(_),N),
        count(reachable_transitions(_,_,_),N1).


run3 :-
        statistics(0),
        mck(s4,nop), writeln(yes), statistics, !.
run3 :-  writeln(no), statistics.

s3(N,N1) :- retractall(start(_)), gen_start_state(proc(s4), StartState), assert(start(StartState)), count(state(_),N),
        count(reachable_transitions(_,_,_),N1).


run4 :-
        statistics(0),
        mck(s5,nop), writeln(yes), statistics, !.
run4 :-  writeln(no), statistics.

s4(N,N1) :- retractall(start(_)), gen_start_state(proc(s5), StartState), assert(start(StartState)), count(state(_),N),
        count(reachable_transitions(_,_,_),N1).


run5 :-
        statistics(0),
        mck(s6,nop), writeln(yes), statistics, !.
run5 :-  writeln(no), statistics.

s5(N,N1) :- retractall(start(_)), gen_start_state(proc(s6), StartState), assert(start(StartState)), count(state(_),N),
        count(reachable_transitions(_,_,_),N1).


run6 :-
        statistics(0),
        mck(s7,nop), writeln(yes), statistics, !.
run6 :-  writeln(no), statistics.

s6(N,N1) :- retractall(start(_)), gen_start_state(proc(s7), StartState), assert(start(StartState)), count(state(_),N),
        count(reachable_transitions(_,_,_),N1).


run7 :-
        statistics(0),
        mck(s8,nop), writeln(yes), statistics, !.
run7 :-  writeln(no), statistics.

s7(N,N1) :- retractall(start(_)), gen_start_state(proc(s8), StartState), assert(start(StartState)), count(state(_),N),
        count(reachable_transitions(_,_,_),N1).


run8 :-
        statistics(0),
        mck(s10,nop), writeln(yes), statistics, !.
run8 :-  writeln(no), statistics.

s8(N,N1) :- retractall(start(_)), gen_start_state(proc(s10), StartState), assert(start(StartState)), count(state(_),N),
        count(reachable_transitions(_,_,_),N1).


run9 :-
        statistics(0),
        mck(s15,nop), writeln(yes), statistics, !.
run9 :-  writeln(no), statistics.

s9(N,N1) :- retractall(start(_)), gen_start_state(proc(s15), StartState), assert(start(StartState)), count(state(_),N),
        count(reachable_transitions(_,_,_),N1).


run10 :-
        statistics(0),
        mck(s18,nop), writeln(yes), statistics, !.
run10 :-  writeln(no), statistics.

s10(N,N1) :- retractall(start(_)), gen_start_state(proc(s18), StartState), assert(start(StartState)), count(state(_),N),
        count(reachable_transitions(_,_,_),N1).


run11 :-
        statistics(0),
        mck(s20,nop), writeln(yes), statistics, !.
run11 :-  writeln(no), statistics.

s11(N,N1) :- retractall(start(_)), gen_start_state(proc(s20), StartState), assert(start(StartState)), count(state(_),N),
        count(reachable_transitions(_,_,_),N1).

